#ifndef _INCLUDE_FACTORYH

#define _INCLUDE_FACTORYH

// This header contains the standard declarations a Module DLL will use to define
// it's interface to the rest of the DLL's. The "Factory" is an exported object
// from each Module DLL which can be used to generate new Dialog Pages, and Module
// Objects. It constructs and enumerates all the objects a Module DLL supports.

// This is semi-nonstandard header file in that it is only meant to be included
// inside the body of the main .cpp file for the DLL application.

#include "Module.h"

class _declspec(dllexport) TFactory : public TModuleFactory
{
public:
   TFactory();
   TModule* CreateModule(int Index);
   CModPropPage* CreatePage(int Index);
};

// Declaration so that Factory will be exported
extern "C" _declspec(dllexport) TFactory Factory;

// And an instance so Factory will be constructed and allocated
TFactory Factory;

#endif // _INCLUDE_FACTORYH
