#ifndef _Power_H_
#define _Power_H_

#undef DECL
#ifdef UTILS_DLL
#define DECL _declspec(dllexport)
#else
#define DECL _declspec(dllimport)
#endif

const MAX_THREADS = 256;


class DECL TPowerMgr
{
public:
   TPowerMgr();
   ~TPowerMgr();
public:
   enum TMode {pwr_None, pwr_Minute, pwr_Second, pwr_Standby, pwr_Fast};
   TMode SetSpeed(TMode Mode);
   TMode GetSpeed();
   void Sleep(DWORD dwMilliseconds);
   DWORD WaitForSingleObject(HANDLE hHandle, DWORD dwMilliseconds);
   DWORD WaitForMultipleObjects(DWORD nCount, CONST HANDLE *lpHandles, BOOL bWaitAll, DWORD dwMilliseconds);
   void Shutdown();
   DWORD SelectSpeed(DWORD dwMilliseconds);
   DWORD MSTil(class CTime& WakeTime);
   INT64 GetSyncedTickCount();
   INT64 GetSyncedSystemTime();
   void DetectTimeChange();
public:
   void RegisterThread();
   void UnRegisterThread();
private:
   TMode SpeedList[MAX_THREADS];
   int SpeedCount;
   CRITICAL_SECTION Lock;
   CRITICAL_SECTION TimeLock;
   void ComputeSpeed();
   void SwitchSpeed(TMode Mode);
   TMode CurrentSpeed;
public:
   DWORD TlsIndex;
   DWORD TimeChangeCounter;
};

extern "C" DECL TPowerMgr PowerMgr;

#endif // _Power_H_
